/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

package org.apache.geronimo;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class for Servlet: PageServlet
 * 
 * @web.servlet name="PageServlet" display-name="PageServlet"
 * 
 * @web.servlet-mapping url-pattern="/page"
 * 
 */
public class PageServlet extends HttpServlet {
    static final long serialVersionUID = 1L;

    /* (non-Javadoc)
     * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    protected void doGet(HttpServletRequest request,
        HttpServletResponse response) throws ServletException, IOException {
        
        String cometId = request.getParameter("sessionId");
        String delay = request.getParameter("delay");
        String codeStr = request.getParameter("code");
        //Uncomment the following line to help with debugging
        //System.out.println("sessionId:" + cometId + "; delay:" + delay + "; code:" + codeStr);

        try {
            Thread.sleep(Integer.parseInt(delay));
        } catch (NumberFormatException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }


        String uri = "dummy.html";  

        int code = Integer.parseInt(codeStr);
        switch (code) {
        case 200: request.getRequestDispatcher(uri).forward(request, response); break;
        
        case 302: 
        response.sendRedirect("http://" + request.getServerName() + ":" + request.getLocalPort() + request.getContextPath() + "/" + uri);
            break;
        
        case 403:
        case 404:
        case 500: response.sendError(code, codeStr);
            /*try  { 
                int test = 1/0;
            } 
            catch (Exception e) {
                    throw new ServletException("Servlet caught a ServletException: " + e.getMessage()); 
            }*/         
            break;
        }
        
        return;
    }

}